<template>
        <div class="header-nav-wrap">
            <div :class="[
                'header-nav',
                 {
                     'header-nav--active': visibleMenu
                 }
            ]">
                <div
                    class="header-nav__hamburger"
                    @click="changeVisibleMenu"
                >
                    <base-svg-icon
                        id="hamburger"
                        width="42"
                        height="40"
                        viewBox="0 0 42 40"
                    />
                </div>
                <div :class="[
                    'header-nav__content',
                     {
                         'header-nav__content--active': visibleMenu
                     }
                ]">
                    <!-- Desktop menu start -->
                    <div
                        v-if="!onMobileMenu"
                        class="header-nav__list"
                    >
                        <router-link
                            to='/ois'
                            class="header-nav__link"
                        >
                            <div class="header-nav__text">{{ $t('ois.upload.my_ois') }}</div>
                        </router-link>
                        <router-link
                            to='#'
                            class="header-nav__link"
                        >
                            <div class="header-nav__text">
                                {{ $t('header.menu.favorites') }}
                                <span class="header-nav__text-favorites"> {{ favorites }}</span>
                            </div>
                        </router-link>
                        <div
                            class="header-nav__link header-nav__link--grouping"
                            @click="changeVisibleMenu"
                        >
                            <div class="header-nav__text header-nav__text--login-name">{{ accountName }}</div>
                            <div
                                v-show="visibleMenu"
                                class="header-nav__grouping"
                            >
                                <div class="header-nav__grouping-item">
                                    <router-link
                                        to='/profile'
                                        class="header-nav__link"
                                    >
                                        <div class="header-nav__text">{{ $t('header.menu.profile') }}</div>
                                    </router-link>
                                    <router-link
                                        to='/profile/settings'
                                        class="header-nav__link"
                                    >
                                        <div class="header-nav__text">{{ $t('header.menu.settings') }}</div>
                                    </router-link>
                                    <div class="header-nav__link">
                                        <div
                                            class="header-nav__text"
                                            @click="logout"
                                        >
                                            {{ $t('header.menu.exit') }}
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                    <!-- Desktop menu end -->
                    <!-- Mobile menu start -->
                    <div
                        v-if="onMobileMenu"
                        v-show="visibleMenu"
                        class="header-nav__grouping-list"
                    >
                        <div class="header-nav__grouping-list-content">
                            <div class="header-nav__grouping-item">
                                <router-link
                                    to='/profile'
                                    class="header-nav__link"
                                >
                                    <div class="header-nav__text">{{ $t('ois.upload.my_ois') }}</div>
                                </router-link>
                                <router-link
                                    to='/profile'
                                    class="header-nav__link"
                                >
                                    <div class="header-nav__text">
                                        {{ $t('header.menu.favorites') }}
                                        <span class="header-nav__text-favorites"> {{ favorites }}</span>
                                    </div>
                                </router-link>
                                <router-link
                                    to='/profile'
                                    class="header-nav__link"
                                >
                                    <div class="header-nav__text">{{ $t('header.menu.profile') }}</div>
                                </router-link>
                                <router-link
                                    to='/profile/verify'
                                    class="header-nav__link"
                                >
                                    <div class="header-nav__text">{{ $t('header.menu.identification') }}</div>
                                </router-link>
                                <router-link
                                    to='/profile/settings'
                                    class="header-nav__link"
                                >
                                    <div class="header-nav__text">{{ $t('header.menu.settings') }}</div>
                                </router-link>
                                <div class="header-nav__link">
                                    <div
                                        class="header-nav__text"
                                        @click="logout"
                                    >
                                        {{ $t('header.menu.exit') }}
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                    <!-- Mobile menu end -->
                </div>
            </div>
        </div>
</template>

<script>
import { API_BOOKMARKS_COUNT } from 'const/api';

export default {
    name: 'header-nav',
    data() {
        return {
            visibleMenu: false,
            favorites: ''
        };
    },
    computed: {
        screenWidth() {
            return this.getValueByProperty('width');
        },
        onMobileMenu() {
            return this.screenWidth < 768;
        },
        accountName() {
            return this.user.email || this.user.phone || 'anonymous';
        },
        ...mapState('account', ['isAuthorized', 'user']),
        ...mapGetters('information', ['getValueByProperty'])
    },
    created() {
        if (this.isAuthorized) {
            this.$http.get(API_BOOKMARKS_COUNT)
                .then(response => {
                    this.favorites = response.data || '';
                });
        }
    },
    methods: {
        changeVisibleMenu() {
            this.visibleMenu = !this.visibleMenu;
        },
        logout() {
            this.$store.commit('account/LOGOUT');
            this.$router.push('/login');
        },
        async old_logout() {
            this.$store.dispatch('setLoader', true);
            await this.$store.dispatch('account/logout')
                .then(() => this.$router.push('/login'))
                .catch((err) => console.log('Ошибка при выходе из ЛК', err))
                .finally(() => this.$store.dispatch('setLoader', false));
        }
    }
};
</script>

<style lang="sass">
    @import '~blocks/header-nav';
</style>
